#! /usr/bin/env python3

import matplotlib.pyplot as plt

import effmass.inputs
import effmass.extrema
import effmass.outputs

settings = effmass.inputs.Settings(extrema_search_depth=0.1, energy_range=0.2)
data = effmass.inputs.Data("OUTCAR", "PROCAR")
segments = effmass.extrema.generate_segments(settings, data)

for segment in segments:
    print(segment)

effmass.outputs.plot_segments(data, settings, segments)
plt.ylim([-5, 8])
plt.savefig('segments.pdf')

def display_effmasses(segment):
    print(segment)
    print("5 pt leastsq effmass: {}".format(segment.five_point_leastsq_effmass()))
    print("FD effmass: {}".format(segment.finite_difference_effmass()))    
    print("weighted leastsq effmass: {}".format(segment.weighted_leastsq_effmass()))

print("Inspect CBM G->L")
display_effmasses(segments[-2])
